#include "TutorialFrameListener.h"
#include "Application.h"
#include "DotScene.h"

Application::Application()
{
}

Application::~Application()
{
}

void Application::createCamera()
{
  mCamera = mSceneMgr->createCamera("PlayerCam");
  mCamera->setNearClipDistance(.0001);
  mCamera->setFarClipDistance(5000);
}

void Application::createFrameListener()
{
  mFrameListener = new TutorialFrameListener(mWindow, mCamera, mSceneMgr);
  //mFrameListener = new ExampleFrameListener(mWindow, mCamera, mSceneMgr);
 
  mRoot->addFrameListener(mFrameListener);
  mFrameListener->showDebugOverlay(false);

}


void Application::createScene()
{
  mSceneMgr->setAmbientLight( ColourValue( .1,.1,.1 ) );
  mSceneMgr->setSkyDome(true, "Examples/CloudySky", 5, 8,2500);
    
  CDotScene scene;
  scene.parseDotScene("Scene.xml", 
        ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME,  
        mSceneMgr
        );


  SceneNode *zelda = mSceneMgr->getRootSceneNode()->createChildSceneNode("ZeldaNode");
  CDotScene scene2;
  scene2.parseDotScene("zeldaS.xml", 
       ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME,  
       mSceneMgr,
       zelda
       );
  
    
  Entity *ent;
  SceneNode *node;
  Vector3 scale(.1, .1, .1);
  zelda->setScale(scale);
//     Entity *ent = mSceneMgr->createEntity("Ninja", "shrine.mesh");
//     SceneNode *node = mSceneMgr->getRootSceneNode()->createChildSceneNode("NinjaNode");
//     node->attachObject(ent);
//     node->setScale(NinjaScale);
    
   
//     Entity *ent = mSceneMgr->createEntity("gingerbread", "gingerbread.mesh");
//     SceneNode *node = mSceneMgr->getRootSceneNode()->createChildSceneNode("GingerNode");
//     node->attachObject(ent);
    
    Light *light = mSceneMgr->createLight("Light1");
    light->setType(Light::LT_POINT);
    light->setPosition(Vector3(250, 150, 250));
    light->setDiffuseColour(ColourValue::White);
    light->setSpecularColour(ColourValue::White);
    
    // Create the scene node
    node = mSceneMgr->getRootSceneNode()->createChildSceneNode("CamNode1", Vector3(-4, 4, 4));
    //node->yaw(Degree(-45));
    node->attachObject(mCamera);
    
    // create the second camera node
    node = mSceneMgr->getRootSceneNode()->createChildSceneNode("CamNode2", Vector3(0, 4, 6));
    
}

void Application::destroyScene()
{
    ExampleApplication::destroyScene();
}
